import java.io.*;
import java.lang.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import pppizza.*;
import grafica.*;


public class Avvio {

	public static void main(String args[])
     	{
         try{
               //lista che utilizza la pizzeria per raccogliere le ordinazioni
               Listaordini lordini=new Listaordini();

               //creo la pizzeria e la sua variabile stato
               Stato_pizzeria stato=new Stato_pizzeria();
               
               
               //queste due istruzioni le uso quando ho una pizzeria su ogni computer
             // Pizzeria pizzeria=new Pizzeria("config/piz_dati.txt",stato,lordini);
             // Lista_Server lserver=new Lista_Server("config/server.txt"); //carico in memoria la lista dei server


                Pizzeria pizzeria=new Pizzeria(args[0],stato,lordini);
            	Lista_Server lserver=new Lista_Server(args[1]); //carico in memoria la lista dei server
               
               
               
               

               //lserver.stampa_lista();                //stampo la lista dei Server conosciuti

               //controllo che il programma sia stato chiuso correttamente altrimenti ripristino il sistema
               boolean ripristino=true;
               if( new File("backup/ordini.obj").exists())
               {
                    int selection=JOptionPane.showConfirmDialog(null,"Il sistema non  stato chiuso correttamente.\nVuoi ripristinare gli ordini non serviti?","Ripristino "+pizzeria.getNome(),JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE);
                    if (selection==JOptionPane.OK_OPTION)
                    {
                         //riempire la lista con le ordinazioni non servite. Differenza di due file.
                         lordini.F_caricalista("backup/ordini.obj");
                         lordini.F_scaricalista("backup/ordini_serviti.obj");
                         ripristino=false;
                    }
               }

               //creo le strutture di backup che raccolgono le ordinazioni controllando che l'ultima terminazione del programma sia stata corretta
               Fileordini_writer NS_fordini=new Fileordini_writer("backup/ordini.obj");
               Fileordini_writer S_fordini=new Fileordini_writer("backup/ordini_serviti.obj");
               if(!ripristino)
                    NS_fordini.salva_lista_ordini(lordini);

               Finestra_principale finestra=new Finestra_principale(pizzeria,lserver,S_fordini,NS_fordini);
               JFrame fp=finestra;
               fp.show();

               //creo il server che riceve le ordinazioni
               new ThS_attesa_ordini(finestra,pizzeria,lserver,NS_fordini).start();

               //questo thread riattiva i server ogni 6 minuti
               new Th_RiattivaServer(finestra.textArea,pizzeria,lserver).start();

          }catch(IOException ioe)
          {
               JOptionPane.showMessageDialog(null, "Errore nell'apertura del sistema.\nControllare i file di Config!", "Error Config", JOptionPane.ERROR_MESSAGE);
               System.exit(0);
          }

     }

     public Avvio() {}
};
