/**
  @version aprile 2001
  @author Perticarini Emanuele
*/
package pppizza;
import java.io.*;
import java.lang.*;
import java.awt.*;
import java.util.*;
import javax.swing.JTextArea;

import grafica.*;

/**
  @Crea un ogetto ordinazione costituito da una stringa contenente il nome del cliente.
  @una stringa contenente l'indirizzo del cliente.
*/
public class Ordinazione implements Serializable
{
     /**nome de cliente*/
	protected String cliente;

     /**indirizzo del cliente*/
	protected String indirizzo;

     /**stringa contenente le pizze ordinate*/
     protected String pizze;

     /**indica se l'ordinazione  sul tavolo del pizzaiolo*/
     protected boolean spuntato;


     public Ordinazione()
     {}


	public Ordinazione(String cl,String ind,String ord)
	{
		cliente=cl;
		indirizzo=ind;
          pizze=ord;
          spuntato=false;
     }

/**Stampa a video un ordine*/
     public  void stampaordine()
     {
          int init=0;
          int end=0;
          System.out.println("Nome: "+cliente +"\n"+"Indirizzo: "+ indirizzo+"\nLista pizze:");
          while(end != -1)
          {
               if ((end=pizze.indexOf(".",end))!=-1)
               {
                    Pizza pizza_temp=new Pizza(pizze.substring(init,end));
                    init=++end;
                    System.out.println(pizza_temp.get_Tpizza()+" N: "+pizza_temp.get_Npizza());
               }

          }
     }



/**Stampa in finestra un ordine*/
     public  void stampaordine(JTextArea textArea)
     {
          int init=0;
          int end=0;
          textArea.append("Nome: "+cliente +"\n"+"Indirizzo: "+ indirizzo+"\n");
          while(end != -1)
          {
               if ((end=pizze.indexOf(".",end))!=-1)
               {
                    Pizza pizza_temp=new Pizza(pizze.substring(init,end));
                    init=++end;
                    textArea.append(pizza_temp.get_Tpizza()+" N: "+pizza_temp.get_Npizza()+"\n");
               }
          }
     }





/**conta il numero delle pizze dell'ordinazione*/
     public int num_pizze()
     {
          int count=0;
          int init=0;
          int end=0;
          while(end != -1)
          {
               if ((end=pizze.indexOf(".",end))!=-1)
               {
                    Pizza temp=new Pizza(pizze.substring(init,end));
                    count=count+temp.get_Npizza();
                    init=++end;
               }
          }
          return count;
     }


     public boolean get_spuntato()
     {
          return spuntato;
     }


     public void setspuntato(boolean val)
     {
          spuntato=val;
     }


};
