/**
 * @version Marzo 2001
 * @author Poletti Francesco
 */
package gestore;
import corejava.*; /*package con le librerie per l'acquisizione da imput*/
import Pppizza1.*;
import java.io.*;
import java.net.*;
import java.util.Vector;
import grafica1.*;
import javax.swing.*;

/*thread che gestisce tutte le comunicazioni tra server*/
public class Gestore implements Runnable
{/**Apre un server socket all'indirizzo 2000 per la comunicazione tra i "server" 
   vede il monitor il vettoreserver e il vettore pizzerie*/
 public Gestore(Monitor pol,Vettorepizzerie pol1,Vettoreserver pol2,Finestra_principale pol3 )
   { monitor=pol; vettorepizzerie=pol1; vettoreserver=pol2; finestra=pol3;
   }

      public void run()
      {boolean errore=false,uno=false,due=false;
       BufferedReader in=null;
       PrintWriter out=null;
       ServerSocket s=null;
       String inv=null;
       Socket incoming=null;
       JTextArea tx1=finestra.textarea1(),tx2=finestra.textarea2(),tx3=finestra.textarea3();
          try
          {Server corrente=vettoreserver.corrente();
   	       s = new ServerSocket(corrente.gestore());
           tx3.append("\nSONO PRONTO PER COMUNICARE CON I SERVER \n nella porta: "+ corrente.gestore());
          }
          catch (IOException e1)
          {System.out.println("\nGestore errore nell'apertura Serversocket" + e1);
           System.exit(0);
          }
   		    for (;;)
            {try
             {errore=false;
              incoming = s.accept( );
   		        in = new BufferedReader(new InputStreamReader(incoming.getInputStream()));
              out = new PrintWriter (incoming.getOutputStream(), true /* autoFlush */);
              incoming.setSoTimeout(3000);
			        inv=in.readLine();
             }
             catch (Exception e1)
             {tx3.append("\nGestore errore nell'apertura di una comunicazione " + e1);
              errore=true;
               try
               {in.close();
               }
               catch (Exception e2)
               {
               }
               try
               {incoming.close();
               }
               catch (Exception e2)
               {
               }
             }
       if(!errore)
			 {if (inv.startsWith("aggiungi"))
			    {new Thread(new Modifica(incoming,in,out,vettorepizzerie,inv,finestra)).start();
          }
        else
			    if (inv.startsWith("sottrai"))
			     {new Thread(new Modifica(incoming,in,out,vettorepizzerie,inv,finestra)).start();
           }
		      else
           if(inv.startsWith("statotrue"))
			     { new Thread(new Modifica2(incoming,in,out,vettorepizzerie,inv,finestra)).start();
			     }
				   else
            if(inv.startsWith("statofalse"))
			      { new Thread(new Modifica3(incoming,in,out,vettorepizzerie,inv,finestra)).start();
			      }
				    else
			        if(inv.equals("aggiorna"))
			        { new Thread(new Aggiornain(incoming,in,out,monitor,vettorepizzerie,vettoreserver,finestra)).start();
			        }
				       else
				        if(inv.equals("blocca"))
                 { new Thread(new Blocca(incoming,in,out,monitor,vettoreserver,finestra)).start();
			           }

        }
       }
      }

      private Vettoreserver vettoreserver;
      private Vettorepizzerie vettorepizzerie;
      private Monitor monitor;
      private Finestra_principale finestra;

}
   


