/**
 * @version Marzo 2001
 * @author Poletti Francesco
 */
import monitor2.*;
import pizzerie.*;
import gestore.*;
import ordini.*;
import verifica.*;
import java.io.*;
import java.net.*;
import Pppizza1.*;
import java.util.*;
import grafica1.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
public class Pol22
{  public static void main(String[] args )
   {  /*creo il vettore dei server passandogli come argomento il server corrente*/
      boolean chiusura=false;
      BufferedReader  in=null;
      PrintWriter  out=null;
      Vettoreserver vettoreserver=null;


	  if (args.length==1 )
	      {vettoreserver=new Vettoreserver(args[0]);
		    }
	  else
	      {System.out.println("Ci vuole l'argomento esatto:numero vettoreserver");
         vettoreserver=new Vettoreserver();
         vettoreserver.stampa();
		     System.exit(0);
		    }
    /*in numerocorrente il numero del servercorrente nel vettore di server*/
	  int numerocorrente=vettoreserver.numerocorrente();

	  /*in stringacorrente il numero che rappresenta il
	  server come posizione nel vettoreserver*/
	  String stringacorrente="";
	  stringacorrente=String.valueOf(numerocorrente);

	  /*numero dei server nel vettore server*/
    int numero=vettoreserver.numero();
    Server pippo=vettoreserver.corrente();

	  /*creo il vettore delle pizzerie*/
	  Vettorepizzerie vettorepizzerie=new Vettorepizzerie();
    vettorepizzerie.stampa();
    /*Creo la finestra per l'utente passandogli anche il nome del server*/
    Finestra_principale finestra=new Finestra_principale("Server "+ pippo.indirizzo()+" "+stringacorrente );
    JFrame fp=finestra;
    fp.show();
    JTextArea tx1=finestra.textarea1(),tx2=finestra.textarea2(),tx3=finestra.textarea3();
	  Socket b=null,aggiornatore=null;
	  Monitor2 monitor2=new Monitor2();
	  boolean primo=true,risponde;
	  int contatore=0;
    /*ciclo fra i server per trovare quelli attivi*/
	  for (int i=0;i<numero;i++)
           {
				   pippo=vettoreserver.torna(i);
	  			   if (pippo.stato()!=2)
				   {risponde=true;
				    try
					  {b=new Socket(pippo.indirizzo(),pippo.gestore());
					  }
					  catch(IOException exception)
					  {/*Il server dovrebbe essere non attivo*/
             risponde=false;
            }
				    /*non ha risposto quindi non lo cosidero nel vettore
					  server il suo stato  gia zero*/
					if (!risponde)continue;
				    /*il server  attivo*/
					monitor2.incrementa();
          contatore++;
					pippo.cambiastato(1);
					if(primo)
				    {tx3.append("Ho trovato un aggiornatore");
					   primo=false;
				     aggiornatore=b;
					   new Thread(new Inviaaggiorna(b,monitor2,stringacorrente,tx3)).start();
				    }
				    else
					{
					 new Thread(new Inviablocca(b,monitor2,stringacorrente,tx3)).start();
				    }
				   }
				  }
	if(!primo)
	/*c' un altro server*/
	{try
	   {
       monitor2.processi();
	     in = new BufferedReader(new InputStreamReader(aggiornatore.getInputStream()));
       out = new PrintWriter (aggiornatore.getOutputStream(), true /* autoFlush */);
       aggiornatore.setSoTimeout(10000);
	     out.println("ok");
		   String risp=in.readLine();
	     vettorepizzerie.aggiorna(risp);
		   monitor2.sblocca(contatore);
		   out.close();
		   in.close();
		   aggiornatore.close();
		 }
	 catch (Exception e)
		 {  System.out.println("\nPol22 errore nella comunicazione" + e);
        try
         {in.close();
          out.close();
         }
         catch (Exception e1)
		     {System.out.println("\nPol22 errore anche nella chiusura" + e1);
         }
     System.exit(0);
     }
	 }
	  Monitor monitor=new Monitor();
	  vettoreserver.stampa(finestra.textarea2());
    vettoreserver.stampa();
      /*creo l'oggetto monitor*/
    vettorepizzerie.stampa(finestra.textarea1());
	  Gestore gestore=new Gestore(monitor,vettorepizzerie,vettoreserver,finestra);
	  new Thread(gestore).start();
	  Pizzerie pizzerie=new Pizzerie(monitor,vettorepizzerie,vettoreserver,finestra);
    new Thread(pizzerie).start();
    Ordini ordine=new Ordini(monitor,vettorepizzerie,vettoreserver,finestra);
	  new Thread(ordine).start();
    Gestoreverifica gverifico=new Gestoreverifica(monitor,vettorepizzerie,vettoreserver,finestra);
	  new Thread(gverifico).start();
    Verifico verifico=new Verifico(monitor,vettorepizzerie,vettoreserver,finestra);
	  new Thread(verifico).start();

 }

}

