 /**
  * @version Marzo 2001
  * @author Poletti Francesco
  */
 package Pppizza1; 
 import corejava.*; /*package con le librerie per l'acquisizione da imput*/
 import java.io.*;
 import java.util.*;
 import javax.swing.*;
 import grafica1.*;
 import java.awt.*;
 public class Vettorepizzerie 
 {
  /*costruttore che dai file delle pizzerie costruisce il vettore lista di pizzerie*/
  public Vettorepizzerie()  
   {Listapizzeria lista=new Listapizzeria();
    Pizzeria pippo;
    int n=0,cont1,cont2;	
	Intero numero;
	ObjectInputStream in;
	try
	{in=new ObjectInputStream(new FileInputStream("totale.dat"));
 	 totale=(Vector)in.readObject();
	 in.close();
	 cont2=totale.size();
	 cont2--;
	 numero=(Intero)totale.get(cont2);
	 cont1=numero.ritorna();
	 while (cont1!=0)
	    {in=new ObjectInputStream(new FileInputStream("lista" + n + ".dat"  ));
	     pippo=(Pizzeria)in.readObject();
         lista=new Listapizzeria(pippo); 
		 numero=(Intero)totale.get(n);
		 cont2=numero.ritorna();
	     cont2--;
		    while(cont2!=0)
                 {
		          pippo=(Pizzeria)in.readObject();
	              lista.aggiungiel(pippo);	     
				  cont2--;
				 }
		n++;
		vettorepizzerie.add(lista);
		cont1--;
		in.close();
	   }
	  }  
	  catch(Exception e)
	  {System.out.print("Errore vettorepizzerie:" + e);
	   System.exit(1);	 
	  }
   }
  
 private Vector vettorepizzerie=new Vector(3,1);
 private Vector totale;
 
 /**trova la pizzeria meno carica della zona vi inserisce l'ordine e ritorna il riferimento alla
   pizzeria scelta se tutte le pizzerie della zona non sono attive torna null*/
  public synchronized Pizzeria trova(int zona,int npizze)
 {Listapizzeria lista=(Listapizzeria)vettorepizzerie.get(zona);
  Pizzeria pol=lista.trova(npizze); 
  return pol; 
 }


 /**mette a npizze lo stato della pizzeria passata come argomento tenendo conto del conteggio */
 public boolean aggiungi(Pizzeria nome,int npizze,int cont)
 {return nome.modifica(npizze,cont);
 }
 /**aggiorna il conteggio e npizze della pizzeria di nome "nome" se necessario*/
 public boolean modifica(int zona,int npizze,String nome,int cont)
 {Listapizzeria lista=(Listapizzeria)vettorepizzerie.get(zona);
  return lista.modifica(nome,npizze,cont);
 }

 /**mette la pizzeria della zona "zona" di nome "nome" nello stato false
 azzerando conteggio e npizze*/
 public boolean cambiastato(int zona,String nome)
 {Listapizzeria lista=(Listapizzeria)vettorepizzerie.get(zona);
  return lista.statofalse(nome);
 }
 /**mette false lo stato della pizzeria passata come argomento*/
 public void statofalse(Pizzeria nome)
 { nome.statofalse();
 }
  /**mette la pizzeria della zona "zona" di nome "nome" nello stato true aggiornando anche il conteggio e il numero di pizze*/
  public boolean statotrue(int zona,String nome,int npizze,int conteggio)
  {Listapizzeria lista=(Listapizzeria)vettorepizzerie.get(zona);
   return lista.statotrue(nome,npizze,conteggio);
 }
 /**aggiunge alla lista della zona "zona" una pizzeria di nome "nome" e indirizzo "ind"
    modificando anche il file*/
 public void aggiungi (int zona,String nome,String ind,int porta)
 {Listapizzeria lista=(Listapizzeria)vettorepizzerie.get(zona);
  Intero n=(Intero)totale.get(zona);
  n.incrementa();
  totale.set(zona,n);
  
  int npizzerie=n.ritorna();
  Pizzeria pol=new Pizzeria(ind,nome,porta);
  lista.aggiungiel(pol);
  Elistapizzeria elemento=lista.primo();
  try
  {ObjectOutputStream out=new ObjectOutputStream(new FileOutputStream("totale.dat"));
   out.writeObject(totale);
   out.close();
   out=new ObjectOutputStream(new FileOutputStream("lista" + zona + ".dat"));
   while(npizzerie!=0)
   {System.out.println(npizzerie);
    pol=elemento.elemento();
    out.writeObject(pol);
    npizzerie--;
    elemento=elemento.prossimo();
   }
   out.close();
  }
  catch(Exception e)
  	  {System.out.print("Errore:" + e);
  	   System.exit(1);	 
	  }
  }  
 /**elimina dalla lista della zona "zona" una pizzeria di nome "nome" e indirizzo "ind"
    modificando anche il file*/
 public synchronized void elimina (int zona,String nome,String ind)
 {Listapizzeria lista=(Listapizzeria)vettorepizzerie.get(zona);
  Intero n=(Intero)totale.get(zona);
  n.decrementa();
  totale.set(zona,n);
  int npizzerie=n.ritorna();
  lista.eliminael(nome,ind);
  Elistapizzeria elemento=lista.primo();
  Pizzeria pol;
  try
  {ObjectOutputStream out=new ObjectOutputStream(new FileOutputStream("totale.dat"));
   out.writeObject(totale);
   out.close();
   out=new ObjectOutputStream(new FileOutputStream("lista" + zona + ".dat"));
   while(npizzerie!=0)
   {System.out.println(npizzerie);
    pol=elemento.elemento();
    out.writeObject(pol);
    npizzerie--;
    elemento=elemento.prossimo();
   }
   out.close();
  }
  catch(Exception e)
  	  {System.out.print("Errore:" + e);
  	   System.exit(1);	 
	  }
  }
  
 /** ritorna il numeri di zone presenti nel vettore*/ 
 public int totale()
 {return vettorepizzerie.size();
 } 
  
 /**restituisce una stringa con tutti i numeri di pizze di tutte le pizzerie del vettore*/ 
 public String numeri()
 {
  String pol="",appoggio;
  int numero=vettorepizzerie.size();
  
  for(int i=0;i<numero;i++)
  {Listapizzeria lista=(Listapizzeria)vettorepizzerie.get(i);
   pol=pol.concat(lista.numeri());
  }
  pol=pol.concat("/");
  return pol;
 } 
 
  /**aggiorna il vettor delle pizzerie sulla base della stringa*/ 
  public synchronized void aggiorna(String pol)
  {
   String aggiorna=pol,appoggio,appoggio1;
   int numero=vettorepizzerie.size(),index,index1;
   index1=pol.indexOf('/');
   for(int i=0;i<numero;i++)
   {Listapizzeria lista=(Listapizzeria)vettorepizzerie.get(i);
    index1++;
	  index=pol.indexOf('/',index1);
	  appoggio=pol.substring(index1,index);
	  lista.aggiorna(appoggio);
	  index1=index;
   }
   
 }

  /**aggiorna il vettore delle pizzerie sulla base della stringa se necessario*/
  public synchronized void verifica(String pol)
  {
   String aggiorna=pol,appoggio,appoggio1;
   int numero=vettorepizzerie.size(),index,index1;
   index1=pol.indexOf('/');
   for(int i=0;i<numero;i++)
   {Listapizzeria lista=(Listapizzeria)vettorepizzerie.get(i);
    index1++;
	  index=pol.indexOf('/',index1);
	  appoggio=pol.substring(index1,index);
	  lista.verifica(appoggio);
	  index1=index;
   }

 }
 public synchronized void stampa()
 {int cont1,cont2;
  Intero numero;
  Listapizzeria lista;
  cont2=totale.size();
  cont2--;
  numero=(Intero)totale.get(cont2);
  cont1=numero.ritorna();
  cont2=0;
  while(cont1!=0)
  {lista=(Listapizzeria)vettorepizzerie.get(cont2);
   System.out.println("");  
   System.out.println("Stampo le pizzerie della zona:" + cont2);
   System.out.println("");
   lista.stampalista();
   cont2++;
  
   cont1--;
  }
 }
 public synchronized void stampa(JTextArea textarea)
 {textarea.setEditable(true);
  textarea.selectAll();
  textarea.cut();
  textarea.setEditable(false);
  int cont1,cont2;
  Intero numero;
  Listapizzeria lista;
  cont2=totale.size();
  cont2--;
  numero=(Intero)totale.get(cont2);
  cont1=numero.ritorna();
  cont2=0;
  while(cont1!=0)
  {lista=(Listapizzeria)vettorepizzerie.get(cont2);
   if(cont2!=0)
   textarea.append("\n Pizzerie della zona: " + cont2+"\n");
   else
   {
    textarea.append(" Pizzerie della zona: " + cont2+"\n");
   }
   lista.stampalista(textarea);
   cont2++;
  
   cont1--;
  }
 }
}