/**
 * @version Marzo 2001
 * @author Poletti Francesco
 */
package verifica;
import corejava.*; /*package con le librerie per l'acquisizione da imput*/
import Pppizza1.*;
import java.io.*;
import java.net.*;
import java.util.Vector;
import grafica1.*;
import javax.swing.*;
public class Inviaverifica implements Runnable
{ /**invia al server il messaggio "verifica" riceve la stringa numeri sblocca
     il processo principale */
  public Inviaverifica(Server pol,PipedInputStream pol1,PipedOutputStream pol2,JTextArea pol3)
   { server=pol;pipein=pol1;pipeout=pol2;tx=pol3;
   }
   public void run()
   {
    Socket s=null;
    BufferedReader in=null,in1=null;
    PrintWriter out=null,out1=null;
    boolean chiusura=false,errorecomunicazione=false,errore=false;
    String risp1="",risp="";
    try
    {in1 = new BufferedReader(new InputStreamReader(pipein));
     out1 = new PrintWriter (pipeout, true /* autoFlush */);
     /*apro la socket con il server*/
     s=new Socket(server.indirizzo(),server.verifica());
     in = new BufferedReader(new InputStreamReader(s.getInputStream()));
     out = new PrintWriter (s.getOutputStream(), true /* autoFlush */);
     s.setSoTimeout(10000);
    }
    catch (Exception e)
    {
     errorecomunicazione=true;
     server.cambiastato(0);
     out1.println("fallito");
     try
     {/*attendo la risposta da Verifico*/
      risp=in1.readLine();
     }
     catch (Exception e1)
     {
     }
    }
    if(!errorecomunicazione)
    {out1.println("ok");
     try
     {/*Verifico mi comunica se  il verificatore oppure no*/
      risp1=in1.readLine();
     }
     catch (Exception e)
     {
      errore=true;
     }
     if(!errore)
     {if(risp1.equals("fineverifica"))
       out.println(risp1);
       else
       {try
		    {/*comunico al server di bloccarsi in verifica e aspetto la risposta*/
         out.println("verifica");
         /*leggo lo stato dell'altro server*/
		     risp=in.readLine();
         /*comunico lo stato dell'altro server a Verifico*/
         out1.println(risp);
        }
        catch (Exception e1)
        {tx.append("\nInviaverifica errore nella comunicazione" + e1);
         errorecomunicazione=true;
         out1.println("fallito");
         try
         {risp1=in1.readLine();
         }
         catch (Exception e)
         {
         }
        }
        if(!errorecomunicazione)
        {try
		     {risp1=in1.readLine();
          /*comunico al server il nuovo stato e di sbloccarsi attendendo la risposta*/
  		    out.println(risp1);
          risp=in.readLine();
          /*comunico a Verifico che il server  sbloccato*/
          out1.println("ok");
          risp1=in1.readLine();
         }
         catch (Exception e1)
         {tx.append("Inviaverifica errore nella comunicazione" + e1);
          out1.println("fallito");
          try
          {risp1=in1.readLine();
          }
          catch (Exception e)
          {
          }
         }
        }
       }
     }
    }
    /*Chiudo la socket*/
    try
      {in.close();
      }
     catch (Exception e1)
     {}
    try
      {out.close();
      }
     catch (Exception e1)
     {}
     try
      {s.close();
      }
     catch (Exception e1)
     {}
     try
      {in1.close();
      }
     catch (Exception e1)
     {}
     try
      {out1.close();
      }
     catch (Exception e1)
     {}
     try
      {pipein.close();
      }
      catch (Exception e1)
      {}
      try
      {pipeout.close();
      }
      catch (Exception e1)
      {}

   }

   private Server server;
   private PipedInputStream pipein;
   private PipedOutputStream pipeout;
   private JTextArea tx;
}



