/**
 * @version Marzo 2001
 * @author Poletti Francesco
 */
package verifica;
import corejava.*; /*package con le librerie per l'acquisizione da imput*/
import Pppizza1.*;
import java.io.*;
import java.net.*;
import java.util.Vector;
import grafica1.*;
import javax.swing.*;
/**Thread che gestisci un ordine eleggendo una pizzeria a cui inoltrare l'ordine
   e comunicando ai server l'aggiornamento*/
public class Verifico implements Runnable
{public Verifico(Monitor pol1,Vettorepizzerie pol2,Vettoreserver pol3,Finestra_principale pol4)
  {monitor=pol1; vettorepizzerie=pol2; vettoreserver=pol3;finestra=pol4;
  }
 public void run()
  { JTextArea tx1=finestra.textarea1(),tx2=finestra.textarea2(),tx3=finestra.textarea3();
    /*definisco il monitor3 per la sincronizzazione della comunicazione dell'ordine agli altri server*/
    Server pippo;
	  int i,n1,n2,n,numero=vettoreserver.numero(),corrente=vettoreserver.numerocorrente();
	  Integer npizze=null,zona=null,npizze1=null,cont=null,cont1=null;
    String pol="";
    boolean[] stato=new boolean[numero],stato1=new boolean[numero];
    PipedInputStream[] ricevo=new PipedInputStream[2*numero];
    PipedOutputStream[] invio=new PipedOutputStream[2*numero];

    BufferedReader[] in=new BufferedReader[numero];
    PrintWriter[] out=new PrintWriter[numero];
    boolean errore=false;
   for(;;)
   {
    try
    {Thread.sleep(600000);
     /*apro le pipe con i Thread InviaVerifica*/
     for (i=0;i<numero*2;i++)
     {ricevo[i]=new PipedInputStream();
      invio[i]=new PipedOutputStream(ricevo[i]);
     }
     for(i=0;i<numero;i++)
     {in[i]= new BufferedReader(new InputStreamReader(ricevo[2*i+1]));
      out[i]= new PrintWriter (invio[2*i], true /* autoFlush */);
     }
     /*invio[i]-->ricevo[i]
       out[i]-->in[i]*/

    }
    catch(Exception e)
    { tx3.append("\nVerifico errore");
      errore=true;
    }

     tx3.append("\nINIZIO VERIFICO");
    /*ciclo tra i server per vedere quelli vivi*/
    /*PRIMO ERRORE*/
    if(!errore)
    {for (i=0;i<numero;i++)
     {if(i!=corrente)
      {pippo=vettoreserver.torna(i);
       new Thread(new Inviaverifica(pippo,ricevo[2*i],invio[2*i+1],tx3)).start();
       stato[i]=true;
       stato1[i]=true;
      }
      else
      {stato[i]=false;
       stato1[i]=false;
      }
     }
     /*stato tutti true tolto il server corente*/
     int primo=0;
     boolean trovato=false;
     n=numero-1;
     for(i=0;i<numero;i++)
     {if(stato[i])
      {try
       {/*leggo se la comunicazione  andata a buon fine oppure no*/
        pol=in[i].readLine();
       }
       catch(Exception e)
       {tx3.append("\nVerifico errore lettura inviaverifica" + e);
        errore=true;
        break;
       }
       if(pol.equals("fallito"))
       {
        stato[i]=false;
        stato1[i]=false;
        n--;
       }
       else
        if(!trovato)
        {primo=i;
         trovato=true;
        }
      }
     }

    /*SECONDO ERRORE*/
    if(!errore )
    {if(primo<corrente || n==0)
     {for(i=0;i<numero;i++)
      if(i!=corrente) out[i].println("fineverifica");
      if(n!=0)
      tx3.append("\nVERIFICO NON SONO IL VERIFICATORE");
      else
      tx3.append("\nVERIFICO SONO L'UNICO SERVER ATTIVO");
     }
     else
      /*INIZIO VERO PROCESSO DI VERIFICA*/
      {monitor.verificatore();
       for(i=0;i<numero;i++)
       if(i!=corrente) out[i].println("verificatore");
       tx3.append("\nVERIFICO SONO IL VERIFICATORE");
       /*in n1 il numero di processi rimasti*/
       for(i=0;i<numero;i++)
        {try
         {/*leggo le stringhe numeri degli altri processi*/
          if(stato[i])
          {
           pol=in[i].readLine();
          }
         }
         catch(Exception e)
         {tx3.append("\nVerifico errore" + e);
          errore=true;
          break;
         }
         if(stato[i])
         {if(pol.equals("fallito"))
          {n--;
           stato1[i]=false;
          }
          else vettorepizzerie.verifica(pol);
         }
        }
        /*TERZO ERRORE*/
        if(!errore)
        {if(n==0)
          {for(i=0;i<numero;i++)
           if(stato[i]) out[i].println("fine");
          }
         else
         {pol=vettorepizzerie.numeri();
          for(i=0;i<numero;i++)
          {if (stato[i]) out[i].println(pol);
          }
          for(i=0;i<numero;i++)
          {try
           {if(stato1[i])
            pol=in[i].readLine();
           }
           catch(Exception e)
           {tx3.append("\nVerifico errore" + e);
            errore=true;
            break;
           }
          }
          for(i=0;i<numero;i++) if (stato[i]) out[i].println("fineverificatore");
         }


         vettorepizzerie.stampa(tx1);

        }
        /*FINE 3 ERRORE*/
      monitor.fineverifica();
      }
      /*FINE VERO PROCESSO DI VERIFICA*/
    }
    /*FINE SECONDO ERRORE*/
     for(i=0;i<numero;i++)
     {try
      {in[i].close();
      }
      catch(Exception e)
      {
      }
      try
      {out[i].close();
      }
      catch(Exception e)
      {
      }
      try
      {ricevo[2*i+1].close();
      }
      catch(Exception e)
      {
      }
      try
      {invio[2*i].close();
      }
      catch(Exception e)
      {
      }
     }
    }

    /*FINE 1 ERRORE*/
    vettoreserver.stampa(tx2);
    tx3.append("\nFINE VERIFICA");
   }
   /*FINE CICLO FOR ESTERNO*/


  }
   private Vettoreserver vettoreserver;
   private Vettorepizzerie vettorepizzerie;
   private Monitor monitor;
   private Finestra_principale finestra;
}


