
//Title:        Rete di pizzerie
//Version:
//Copyright:    Copyright (c) 1999
//Author:       Emanuele Perticarini
//Company:      Home
//Description:  Your description
package grafica;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import java.lang.*;
import javax.swing.*;

import pppizza.*;


/**
  * Permette di aprire delle piccole finestre di dialogo composte da una piccola JTextArea
  * al centro ed un pulsante OK */
public class Finestra_ordini extends JDialog implements ActionListener
{
     //oggetti necessari alla pizzeria
     private Finestra_principale fprincipale;
     private Pizzeria pizzeria;
     private Ordinazione ordine;
     private Lista_Server lserver;
     private Fileordini_writer S_fordini;

     //oggetti per la finestra grafica
     private JButton okButton;
     public  JLabel  n_ordini;
     private JScrollPane scrollPane;
     public  JTextArea textArea;

/**istanzia le variabili e gli oggetti che riceve come argomenti.*/
     public Finestra_ordini(Finestra_principale fp,Pizzeria pz,Ordinazione ord,Lista_Server ls,Fileordini_writer fs)
     {
          fprincipale=fp;
          pizzeria=pz;
          ordine=ord;
          lserver=ls;
          S_fordini=fs;

          Container riga1=getContentPane();
          JPanel pr1=new JPanel();
          n_ordini=new JLabel("Ord.: "+pizzeria.getListaOrdini().get_totalcount_Tostring());
          pr1.add(n_ordini);
          okButton=new JButton(new ImageIcon("icons/PIZZA.gif"));
          pr1.add(okButton);
          okButton.addActionListener(this);
          riga1.add(pr1,"South");

          textArea=new JTextArea(4,10);
          scrollPane=new JScrollPane(textArea);
          getContentPane().add(scrollPane,"Center");
          textArea.setEditable(false);


//da eliminare   fprincipale.num_ordini.setText("Ordini: "+pizzeria.getListaOrdini().conta_ordini_Tostring());
          ordine.stampaordine(this.textArea);
          ordine.setspuntato(true);
          setTitle(pizzeria.getNome());
          setSize(200,200);
          Terminator_Ford x=new Terminator_Ford(fprincipale.num_ordini,pizzeria,ordine);
          addWindowListener(x);
     }

/**raccogli gli eventi: pressione sui pulsanti e lancia i thread necessari a servire
*le richieste.*/
     public void actionPerformed(ActionEvent evt)
     {
          Object source=evt.getSource();
          if(source==okButton)
          {
               if (this.ordine!=null)
               {

                    S_fordini.salva_ordine(ordine);//salvo l'ordinazione servita nel corrispondente file di backup
                    String msg=new String(pizzeria.elimina_ordine(ordine));
                    if(pizzeria.getStatoPizzeria().get_stato()==true)
                         new ThC_aggiorna_server(fprincipale.textArea,msg,lserver).start();
                    fprincipale.num_ordini.setText("Ordini: "+pizzeria.getListaOrdini().conta_ordini_ToString());
                    fprincipale.num_pizze.setText("Pizze: "+pizzeria.getListaOrdini().conta_pizze());
                    this.dispose();
               }
          }
     }
}
