/**
  @version aprile 2001
  @author Perticarini Emanuele
*/

package pppizza;

/**
  * La classe <code>DatiServer</code> permette di creare un oggetto server con le seguenti informazioni:
  * nome del host, porta associata, stato(1 in funzione, 0 non in funzione)
*/
public class DatiServer {

     /** Nome dell'Host */
     protected String name;

     /** Porta in cui il server accetta le chiamate */
     protected int port;

     /** Indica se il server  in funzione oppure no */
     protected int stato;


/**Costruttore di Dafault*/
     public DatiServer()
     {
     }


/**Costrisce l'oggetto sulla base degli argomenti che gli vengono passati*/
     public DatiServer(String n,int p,int s)
     {
          name=n;
          port=p;
          stato=s;
     }


/**Restituisce il nome del Server*/
     public String get_name()
     {
          return name;
     }


/**Restituisce la porta del Server*/
     public int get_port()
     {
          return port;
     }


/**Restituisce lo stato*/
     public int get_stato()
     {
          return stato;
     }


/**attiva lo stato del server */
     public void server_on()
     {
          this.stato=1;
     }


/**Disattiva lo stato del server*/
     public void server_of()
     {
          this.stato=1;
     }

}
