package pppizza;



public class Stato_pizzeria {

     /** Variabile booleana in cui viene scritto se la pizzeria  aperta(true)
     * o chiusa(false)*/
     protected boolean stato;

     /** Contatore inizializzato a zero nel costruttore e per il quale vengono forniti due
     * metodi. Uno per aumnetarlo e uno per decrementarlo. Serve per conteggiare tutte le operazioni
     * fatte sulle ordinazioni*/

     protected int counter;



     public Stato_pizzeria()
     {
          stato=false;
          counter=0;
     }



     public boolean get_stato()
     {
     return stato;
     }


     public int get_count()
     {
          return counter+1;
     }

     public String get_count_ToString()
     {
          String temp=new String();
          temp=temp.valueOf(counter);
          return temp;
     }


     /** pone true nella variabile stato */
     public synchronized void accettaordini()
     {
          stato=true;
          notifyAll();
     }

     /** pone false nella variabile stato */
     public synchronized void rifiutaordini()
     {
          stato=false;
          notifyAll();
     }

     /** incrementa il contatore */
     public synchronized int aggiorna_count()
     {
          counter++;
          return counter;
     }

     /** riduce il contatore */
     public synchronized void riduci_count()
     {
          counter--;
          notifyAll();
     }


}