
package monitor2;

import javax.swing.JTextArea;
/**
 *  Classe Monitor2.
 *  @author Poletti Francesco
 *  @version Monitor1 2.0 
 */
public class Monitor2 {
public Monitor2() {
		contaprocessi=0;
    urgentCount=0;
    mutex=new Mutex();
    urgentQueue = new Urgent(this);
		vc = new Cond(this);
		vc1=new Cond(this);
	}
	
    	private  int contaprocessi,contaprocessi1;
      Mutex mutex;
	    Urgent urgentQueue;
      int urgentCount;
    	private  Cond vc;
		  private  Cond vc1;

	/**
	 * Da invocare come prima istruzione di una procedure entry;
	 * permette di acquisire il monitor
	 */
	protected void entramonitor() {
		mutex.Wait();
	}

	/**
	 * Da invocare come ultima istruzione di una procedure entry;
	 * permette di rilasciare il monitor
	 */
	protected void escimonitor() {
		if (urgentCount > 0)
		{
		  // System.out.println(Thread.currentThread()+"esco dal monitor e signal su urgent");
		  urgentQueue.Signal();
		}
		else 
		{
		  // System.out.println(Thread.currentThread()+"esco dal monitor e signal su mutex");
		  mutex.Signal();
		}
	}

	/**
 	 * incrementa il numero di processi attivi
	 */
   	public void incrementa()
	    {
	  	  entramonitor();
        contaprocessi++;
		    escimonitor();
    	}
	/**
 	 * incrementa il numero di processi attivi
	 */
   	public void incrementa(JTextArea tx)
	    {
	  	  entramonitor();
        contaprocessi++;
        tx.append("\nHo incrementato num processi: "+ contaprocessi);
		    escimonitor();
    	}
	/**
 	 decrementa il numero di processi attivi e se contaprocessi=0 e vc.queue!=0 libero
	 il processo comunque sia mi blocco sulla vc1
	 */
    	public void decrementa() {
	  	entramonitor();
      contaprocessi--;
		if (vc.queue() && contaprocessi==0)
		{
		 vc.Signal();
		}
		vc1.Wait();
		escimonitor();
	    }
	/**
 	 decrementa il numero di processi attivi e se contaprocessi=0 e vc.queue!=0 libero
	 il processo comunque sia mi blocco sulla vc1
	 */
    	public void decrementa(JTextArea tx)
    {
	  	entramonitor();
      contaprocessi--;
      tx.append("\nDecrementa ho decrementato num processi: "+ contaprocessi);
		if (vc.queue() && contaprocessi==0)
		{tx.append("\nDecrementa vado a sbloccare il processo  principale");
		 vc.Signal();
		}
    tx.append("\nDecrementa mi blocco sulla variabile condizione");
		vc1.Wait();
    tx.append("\nDecrementa mi sono sbloccato");
		escimonitor();
	    }

	public void decrementa1() {
		  	entramonitor();
        contaprocessi--;
		    if (vc.queue() && contaprocessi==0)
			{
			 vc.Signal();
			 }

			escimonitor();
	    }
	public void decrementa1(JTextArea tx) {
		  	entramonitor();
        contaprocessi--;
        tx.append("\nDecrementa1 ho decrementato num processi: "+ contaprocessi);
		    if (vc.queue() && contaprocessi==0)
			{tx.append("\nDecrementa1 vado a sbloccare il processo  principale");
			 vc.Signal();
			 }

			escimonitor();
	    }
	/**
	 se ci sono processi attivi si blocca sulla variabile condizione
    */
	    	public void processi()
     {
		  	entramonitor();
			if (contaprocessi!=0)
			{
			 vc.Wait() ;
			}
			escimonitor();
		    }

	/**
	 se ci sono processi attivi si blocca sulla variabile condizione
    */
	    	public void processi(JTextArea tx)
      {
		  	entramonitor();
			if (contaprocessi!=0)
			{tx.append("\nProcessi mi blocco sulla variabile condizione");
			 vc.Wait() ;
			}
			escimonitor();
		    }
/**
	 sblocco tutti i processi sulla variabile vc[1]
    */
	    	public void sblocca(int n){
		  	entramonitor();
			if(vc1.queue())
			{
			 contaprocessi=n;
			 int contatore=n;
			 for(int i=0;i<contatore;i++) vc1.Signal();
			}
			if(contaprocessi!=0)
			{
			 vc.Wait();
			}
			escimonitor();

		    }
/**
	 sblocco tutti i processi sulla variabile vc[1]
    */
	    	public void sblocca(int n,JTextArea tx)
    {
      entramonitor();

			if(vc1.queue())
			{tx.append("\nSblocca metto contaprocessi="+n);
			 contaprocessi=n;
			 vc1.Signal();
			}
			if(contaprocessi!=0)
			{tx.append("\nSblocca mi blocco sulla variabile condizione");
			 vc.Wait();
			}
			escimonitor();

		    }

}

