/**
 * @version Marzo 2001
 * @author Poletti Francesco
 */
package ordini;
import corejava.*; /*package con le librerie per l'acquisizione da imput*/
import Pppizza1.*;
import java.io.*;
import java.net.*;
import java.util.Vector;
import grafica1.*;
import javax.swing.*;
/**Thread che gestisce un ordine eleggendo una pizzeria a cui inoltrare l'ordine
   e comunicando ai server l'aggiornamento*/
public class Gestisciordine implements Runnable
{public Gestisciordine(Socket pol1,Monitor pol2,Vettorepizzerie pol3,Vettoreserver pol4,Finestra_principale pol5)
  { s=pol1; monitor=pol2; vettorepizzerie=pol3; vettoreserver=pol4; finestra=pol5;
  }
  public void run()
   {JTextArea tx1=finestra.textarea1(),tx2=finestra.textarea2(),tx3=finestra.textarea3();
    BufferedReader in1=null,in=null;
    PrintWriter out1=null,out=null;
    /*definisco il monitor1 per la sincronizzazione della comunicazione dell'ordine agli altri server*/
    Monitor1 monitor1=new Monitor1();
    tx3.append("\nGESTISCIORDINE :e' ARRIVATO UN'ORDINE" );
    Socket s1=null;
	  Pizzeria pol=null;
	  String ord="",risp="",xml="",appoggio="",appoggio1="",risposta="";
	  int index,index1,index2,numero=vettoreserver.numero();
	  Integer npizze=null,zona=null,npizze1=null,cont=null;
    boolean erroreapertura=false,finito=false;
    try
     {in = new BufferedReader(new InputStreamReader(s.getInputStream()));
      out = new PrintWriter (s.getOutputStream(), true /* autoFlush */);
     }
    catch(IOException e)
	  {erroreapertura=true;
     System.out.println("\nErrore nell'apertura lettura/scrittura dell'ordine" + e);
    }
    if (!erroreapertura)
	  { try
       {s.setSoTimeout(5000);
        /*leggo l'ordine*/
	      ord=in.readLine();
	      /*rispondo all'ordinatore*/
	      out.println("ok");
	      /*leggo la stringa xml*/
	      xml=in.readLine();
        /*trasformo la stringa ord in un'ordine*/
        index1=ord.length();
  	    index=ord.indexOf(',');
        appoggio=ord.substring(0,index);
        zona=new Integer(appoggio);
	      index++;
  	    appoggio=ord.substring(index,index1);
	      npizze=new Integer(appoggio);
       }
       catch(Exception e1)
          {tx3.append("\nGestisciordine errore nella lettura dell'ordine" + e1);
           finito=true;
          }


       /*Ho ricevuto l'ordine per intero*/
	     /*se la situazione non  =0 mi metto in coda*/
	     monitor.incrementa();


	     boolean trovata=false;
	     /*cerco la pizzeria*/

     while(!finito)
      {try
	      {while(!trovata)
	       {pol=vettorepizzerie.trova(zona.intValue(),npizze.intValue());
          if (pol==null) break;
	        /*comunicazione pizzeria*/
	        boolean risponde=true,uno=false,due=false;
          try
		      {/*apro la comunicazione con la pizzeria*/
           s1=new Socket(pol.ind(),pol.porta());
           uno=true;
           in1 = new BufferedReader(new InputStreamReader(s1.getInputStream()));
           due=true;
           out1 = new PrintWriter (s1.getOutputStream(), true /* autoFlush */);
          }
          /*errore nella apertura della comunicazione con la pizzeria*/
	        catch(IOException exception)
		      {risponde=false;
           /*cambio lo stato della pizzeria*/
           vettorepizzerie.statofalse(pol);
            try
            {if(uno) s1.close();
             if(due) in1.close();
            }
            catch(IOException e1)
             {
             }
          }
          if (!risponde) continue;
          /*comunico l'ordine alla pizzeria*/
          out1.println("ordine");
          s1.setSoTimeout(10000);
          tx3.append("\nGestisciordine sto aspettando una prima risposta dalla pizzeria");
	        risposta=in1.readLine();
          tx3.append("\nGestisciordine prima risposta: " + risposta);
          if(risposta.equals("false"))
	         {
            vettorepizzerie.statofalse(pol);
            vettorepizzerie.stampa(tx1);
              try
                {in1.close();
                }
              catch (Exception e1)
               {}
              try
               {out1.close();
               }
              catch (Exception e1)
               {}
              try
               {s1.close();
               }
              catch (Exception e1)
               {}
             continue;
           }
          /*ho trovato una pizzeria*/
          tx3.append("\nGestisciordine ho trovato una pizzeria");
	        trovata=true;
         }

         /*fine del ciclo di ricerca di una pizzeria*/

         if(trovata)
          {
           /*mando il file xml alla pizzeria*/
	         out1.println(xml);

           risposta=in1.readLine();
           /*la risposta contiene il conteggio ed il numero attuale di pizze della pizzeria*/
	         
	         index1=risposta.length();
	         index=risposta.indexOf(',');
	         index++;
	         index2=risposta.indexOf(",",index);
	         index2++;
	         index=risposta.indexOf(",",index2);
	         appoggio=risposta.substring(index2,index);
	         npizze1=new Integer(appoggio);
	         index++;
	         appoggio=risposta.substring(index,index1);
	         cont=new Integer(appoggio);
          }
         /*ho comunicato tutto l'ordine alla pizzeria*/
         finito=true;
        }
        catch(Exception e1)
          {tx3.append("\nGestisciordine errore nella comunicazione con la pizzeria: "+ pol.nomep() + "errore" + e1);
           trovata=false;

           vettorepizzerie.statofalse(pol);
           vettorepizzerie.stampa(tx1);
             try
                {in1.close();
                }
              catch (Exception e2)
               {}
              try
               {out1.close();
               }
              catch (Exception e2)
               {}
              try
               {s1.close();
               }
              catch (Exception e2)
               {}
          }
      }
       if(trovata)
        {/*chiudo la comunicazione con la pizzeria perch  andata a buon fine*/
              try
                {in1.close();
                }
              catch (Exception e1)
               {}
              try
               {out1.close();
               }
              catch (Exception e1)
               {}
              try
               {s1.close();
               }
              catch (Exception e1)
               {}
          if (vettorepizzerie.aggiungi(pol,npizze1.intValue(),cont.intValue()))
          {vettorepizzerie.stampa(tx1);
	         /*genero la stringa per l'aggiornamento delle tabelle degli altri server*/
           appoggio1=appoggio1.concat("aggiungi," + zona.intValue() + "," + pol.nomep() + "," + npizze1.intValue() + "," + String.valueOf(pol.conteggio()));
	         Server pippo=vettoreserver.torna(0);
           for (int i=0;i<numero;i++)
	         {pippo=vettoreserver.torna(i);
	          if (pippo.stato()==1)
	          {monitor1.incrementa();
	           new Thread(new Inoltraordine(pippo,appoggio1,monitor1,tx3)).start();
            }
	         }
	         monitor1.processi();
          }
          monitor.decrementa();
          out.println(pol.nomep());
        }
        else
           {monitor.decrementa();
	          out.println("Non so gestire l'ordine");
            tx3.append("\nNon so gestire l'ordine");
           }
    }
              try
                {in.close();
                }
              catch (Exception e1)
               {}
              try
               {out.close();
               }
              catch (Exception e1)
               {}
              try
               {s.close();
               }
              catch (Exception e1)
               {}

  }
   private Intero intero;
   private Socket s;
   private Vettoreserver vettoreserver;
   private Vettorepizzerie vettorepizzerie;
   private Monitor monitor;
   private Finestra_principale finestra;
}

