/**
 * @version Marzo 2001
 * @author Poletti Francesco
 */
package pizzerie; 
import corejava.*; /*package con le librerie per l'acquisizione da imput*/
import Pppizza1.*;
import java.io.*;
import java.net.*;
import java.util.Vector;
import grafica1.*;
import javax.swing.*;
public class Pizzerie implements Runnable
{/*apre un server socket alla porta 1000 che riceve gli ordini per ogni ordine attiva
   il Thread Gestisciordine vede: Monitor,vettorepizzerie,vettoreserver */
 public Pizzerie(Monitor pol,Vettorepizzerie pol1,Vettoreserver pol2,Finestra_principale pol3)
   { monitor=pol; vettorepizzerie=pol1; vettoreserver=pol2; finestra=pol3; }

   public void run()
   {  JTextArea tx1=finestra.textarea1(),tx2=finestra.textarea2(),tx3=finestra.textarea3();
      boolean errorecomunicazione=false;
      ServerSocket s=null;
      BufferedReader in=null;
      PrintWriter out=null;
      String inv="";
      Socket incoming=null;
      Server corrente=null;
      try
      {
	     corrente=vettoreserver.corrente();
       s= new ServerSocket(corrente.pizzerie());
      }
      catch (IOException e)
      {System.out.println("\nPizzerie: errore nell'apertura del server socket");
       try
       {s.close();
       }
        catch (Exception e1)
        {
        }
       System.exit(0);
      }
       tx3.append("\nSONO PRONTO PER RICEVERE COMANDI DALLE PIZZERIE \n nella porta:" + corrente.pizzerie());
		for (;;)
     {try
       {
        incoming= s.accept( );
		    in= new BufferedReader(new InputStreamReader(incoming.getInputStream()));
        out= new PrintWriter (incoming.getOutputStream(), true /* autoFlush */);
		    inv=in.readLine();
       }
       catch (Exception e)
       {tx3.append("\nPizzerie errore nella comunicazione" + e);
        errorecomunicazione=true;
        try
        {in.close();
         out.close();
         incoming.close();
        }
        catch (Exception e1)
        {
        }
       }
      if(!errorecomunicazione)
      {if (inv.startsWith("sottrai"))
		   {monitor.incrementa();
		    new Thread(new Sottrai(incoming,in,out,vettorepizzerie,vettoreserver,monitor,inv,finestra)).start();
       }
       if (inv.startsWith("statotrue"))
		   {
        monitor.incrementa();
		    new Thread(new Statotrue(incoming,in,out,vettorepizzerie,vettoreserver,monitor,inv,finestra)).start();
       }
       if (inv.startsWith("statofalse"))
		   {monitor.incrementa();
		    new Thread(new Statofalse(incoming,in,out,vettorepizzerie,vettoreserver,monitor,inv,finestra)).start();
       }
      }
     }
   }

   private Vettoreserver vettoreserver;
   private Vettorepizzerie vettorepizzerie;
   private Monitor monitor;
   private Finestra_principale finestra;
}

