/**
  * @version Marzo 2001
  * @author Poletti Francesco
  */
package Pppizza1;
import java.lang.*;
import java.io.*;
import corejava.*;
import javax.swing.JTextArea;
public class Listapizzeria 
{
 /**costruttore che non inizializza niente*/
 public Listapizzeria() 
 {
 }
 
 /**costruttore che crea una lista il cui primo oggetto Elistapizzeria 
    contiene pizzeria: primo e coda fanno riferimento allo stesso oggetto*/
 public Listapizzeria(Pizzeria p1) 
  { primo=new Elistapizzeria(p1); 
    coda=primo;  
  }
 
  Elistapizzeria primo,coda;
 
  /**aggiunge un oggetto alla lista con una pizzeria raccogliendo i dati da console*/
  public synchronized void aggiungiel()
  {Pizzeria p1=new Pizzeria();
   Elistapizzeria pol=new Elistapizzeria(p1);
   coda.seguente(pol);
   coda=pol;
  }
  
  /**aggiunge un oggetto alla lista con la pizzeria pol argomento del metodo*/
  public synchronized void aggiungiel(Pizzeria pol)
  {Elistapizzeria pol1=new Elistapizzeria(pol);
   coda.seguente(pol1);
   coda=pol1;
  }
  
  /**elimina l'oggetto Elistapizzeria il cui oggetto Pizzeria ha nome "nome" e indirizzo "host"
     se non la trova ritorna false*/
  public synchronized boolean eliminael(String nome,String host)
  {Elistapizzeria prec,next;
   Pizzeria pol;
   pol=primo.elemento();
   prec=primo;
   next=primo.prossimo();
   if(nome.compareTo(pol.nomep())==0 && host.compareTo(pol.ind())==0) 
   {
    primo=next;
    return true;
   }
   while(next!=coda)
   {pol=next.elemento();
	if(nome.compareTo(pol.nomep())==0 && host.compareTo(pol.ind())==0) 
	   {
	    next=next.prossimo();
		prec.seguente(next);
	    return true;
       }
	 prec=next;
	 next=next.prossimo();
   }
   pol=next.elemento();
   if(nome.compareTo(pol.nomep())==0 && host.compareTo(pol.ind())==0) 
    {
     prec.seguente(null);
	 coda=prec;
   	 return true;
    }
	return false;
  }

  /*ritorna il primo oggetto della lista*/
  public Elistapizzeria primo()
  {return primo;}

  /*ritorna l'ultimo oggetto della lista*/
  public Elistapizzeria coda()
  {return coda;}

  /**mette a "n" il numero di pizze in ordine alla pizzeria di nome "nome" se
  il conteggio  pi grande e se lo stato della pizzeria non  false*/
  public synchronized boolean modifica(String nome,int n,int cont)
  {boolean trovato=false;
   Elistapizzeria next=primo;
   Pizzeria pol;
   pol=next.elemento();
   while(next!=coda && !trovato)
    {if ((nome.compareTo(pol.nomep()))==0)
     {return pol.modifica(n,cont);
     }
	   next=next.prossimo();
	   pol=next.elemento();
    }
   if (!trovato && (nome.compareTo(pol.nomep())!=0)) return false;
   else {
         return pol.modifica(n,cont);
        }
  }


   /**ritorna il numero di pizze in ordine alla pizzeria di nome "nome" */
      public synchronized int numero(String nome)
      {boolean trovato=false;
       Elistapizzeria next=primo;
       Pizzeria pol;
       pol=next.elemento();
       while(next!=coda && !trovato)
        {if ((nome.compareTo(pol.nomep()))==0)
         {return pol.npizza();
         }
    	   next=next.prossimo();
    	   pol=next.elemento();
        }
  	  
       if (!trovato && (nome.compareTo(pol.nomep())!=0)) return 0;
       else {return pol.npizza();
        
            }
  }
  /*cambia lo stato della pizzeria di nome "nome" */
  public synchronized boolean statofalse(String nome)
    {boolean trovato=false;
     Elistapizzeria next=primo;
     Pizzeria pol;
     pol=next.elemento();
     while(next!=coda && !trovato)
     {if ((nome.compareTo(pol.nomep()))==0)
       {pol.statofalse();
        return true;
       }
  	   next=next.prossimo();
  	   pol=next.elemento();
      }
     if (!trovato && (nome.compareTo(pol.nomep())!=0)) return false;
     else {pol.statofalse();
           return true;
          }
    }
  /**cambia lo stato della pizzeria chiamata "nome" mettendolo true aggiorna anche npizze e conteggio*/
  public synchronized boolean statotrue(String nome,int npizze,int conteggio)
      {boolean trovato=false;
       Elistapizzeria next=primo;
       Pizzeria pol;
       pol=next.elemento();
       while(next!=coda && !trovato)
       {if ((nome.compareTo(pol.nomep()))==0)
         {pol.statotrue(npizze,conteggio);
          return true;
         }
    	   next=next.prossimo();
    	   pol=next.elemento();
        }
       if (!trovato && (nome.compareTo(pol.nomep())!=0)) return false;
       else {pol.statotrue(npizze,conteggio);
             return true;
            }
    }
  /**trova la pizzeria meno carica vi aggiunge l'ordine e ritorna la pizzeria trovata*/
  public Pizzeria trova(int npizze)
  {Elistapizzeria next;
   int min;
   Pizzeria pol,pol1;
   next=primo;
   boolean trovato=false,fine=false;
   pol=next.elemento();
   pol1=pol;
   min=pol1.npizza();
   do
   {if(pol.stato()) 
    {pol1=next.elemento();
     trovato=true;
	 min=pol1.npizza();
	}
	if(next!=coda)
	{next=next.prossimo();
     pol=next.elemento();   
    } 
   }
   while(!trovato && next!=coda);
   if(next==coda && !trovato)
   {pol=coda.elemento();
    if(pol.stato())
	{
	 return pol;
    }
	else
	{return null;
	}
   } 
   do
   {if(pol.stato())
    {if(pol.npizza()<min)
	 {pol1=pol;
	  min=pol1.npizza();
	 }
	} 
	if(next!=coda) 
	{next=next.prossimo();
	 pol=next.elemento();
	}
   }
   while(next!=coda );
   pol=coda.elemento();
   if(pol.npizza()<min && pol.stato()) pol1=pol;
   return pol1;
  }
  
  /**ritorna una stringa con tutti i numeri di pizze di ogni pizzeria*/
  public synchronized String numeri()
  {
   Elistapizzeria pol=primo;
   Pizzeria elemento=pol.elemento();
   String risultato="/",appoggio="";
   int numero=elemento.npizza();
   appoggio=appoggio.valueOf(numero);
   risultato=risultato.concat(appoggio);
   risultato=risultato.concat(",");
   appoggio=appoggio.valueOf(elemento.conteggio());
   risultato=risultato.concat(appoggio);
   risultato=risultato.concat(",");
   appoggio=appoggio.valueOf(elemento.stato());   
   risultato=risultato.concat(appoggio);
   risultato=risultato.concat(",");
   
   if (pol!=coda) 
	  do
      {
	   pol=pol.prossimo();
       elemento=pol.elemento();
       appoggio=appoggio.valueOf(elemento.npizza());
	   risultato=risultato.concat(appoggio);
	   risultato=risultato.concat(",");
	   appoggio=appoggio.valueOf(elemento.conteggio());
       risultato=risultato.concat(appoggio);
	   risultato=risultato.concat(",");
	   appoggio=appoggio.valueOf(elemento.stato());   
	   risultato=risultato.concat(appoggio);	   
	   risultato=risultato.concat(",");
       
	  }
	  while(pol!=coda);
	  return risultato;
  }
  
  /**aggiorna la lista sulla base della stringa*/
  public void aggiorna(String pol)
  {
   String numeri=pol,appoggio,valore;
   Boolean stato;
   Integer prova,cont;
   int npizze,index,index1;
   Elistapizzeria pippo=primo;
   Pizzeria elemento=pippo.elemento();
   index=pol.indexOf(',');
   appoggio=pol.substring(0,index);
   prova=new Integer(appoggio);
   index1=index;
   index1++;
   index=pol.indexOf(',',index1);
   appoggio=pol.substring(index1,index);
   cont=new Integer(appoggio);
   index1=index;
   index1++;
   index=pol.indexOf(',',index1);
   appoggio=pol.substring(index1,index);
   stato=new Boolean(appoggio);
   elemento.aggiorna(prova.intValue(),cont.intValue(),stato.booleanValue());
   if (pippo!=coda)
   do
    {pippo=pippo.prossimo();
     elemento=pippo.elemento();
     index1=index;
	   index1++;
	   index=pol.indexOf(',',index1);
	   appoggio=pol.substring(index1,index);
	   prova=prova.valueOf(appoggio);
     index1=index;
	   index1++;
	   index=pol.indexOf(',',index1);
	   appoggio=pol.substring(index1,index);
     cont=cont.valueOf(appoggio);
     index1=index;
	   index1++;
	   index=pol.indexOf(',',index1);
	   appoggio=pol.substring(index1,index);
     stato=stato.valueOf(appoggio);
     elemento.aggiorna(prova.intValue(),cont.intValue(),stato.booleanValue());
   }
    while(pippo!=coda);
  }

    /**aggiorna la lista sulla base della stringa se necessario*/
  public void verifica(String pol)
  {
   String numeri=pol,appoggio,valore;
   Boolean stato;
   Integer prova,cont;
   int npizze,index,index1;
   Elistapizzeria pippo=primo;
   Pizzeria elemento=pippo.elemento();
   index=pol.indexOf(',');
   appoggio=pol.substring(0,index);
   prova=new Integer(appoggio);
   index1=index;
   index1++;
   index=pol.indexOf(',',index1);
   appoggio=pol.substring(index1,index);
   cont=new Integer(appoggio);
   index1=index;
   index1++;
   index=pol.indexOf(',',index1);
   appoggio=pol.substring(index1,index);
   stato=new Boolean(appoggio);
   elemento.verifica(prova.intValue(),cont.intValue(),stato.booleanValue());

   if (pippo!=coda)
   do
    {pippo=pippo.prossimo();
     elemento=pippo.elemento();
     index1=index;
	   index1++;
	   index=pol.indexOf(',',index1);
	   appoggio=pol.substring(index1,index);
	   prova=prova.valueOf(appoggio);
     index1=index;
	   index1++;
	   index=pol.indexOf(',',index1);
	   appoggio=pol.substring(index1,index);
     cont=cont.valueOf(appoggio);
     index1=index;
	   index1++;
	   index=pol.indexOf(',',index1);
	   appoggio=pol.substring(index1,index);
     stato=stato.valueOf(appoggio);
     elemento.verifica(prova.intValue(),cont.intValue(),stato.booleanValue());
    }
    while(pippo!=coda);
  }
  public void stampalista(JTextArea textarea)
  {Elistapizzeria pol=primo.prossimo();
   {primo.stampa(textarea);
    while(pol!=null)
    {pol.stampa(textarea);
     pol=pol.prossimo();
    }
   }
  }
  public void stampalista()
  {Elistapizzeria pol=primo.prossimo();
   {primo.stampa();
    while(pol!=null)
    {pol.stampa();
     pol=pol.prossimo();
    }
   }
  }
 }
