
package Pppizza1;
import monitor.*;

/**
 *  Classe Monitor1.
 *  @author Poletti Francesco
 *  @version Monitor1 1.0
 */
public class Monitor1 {
public Monitor1() {
		contaprocessi=0;
		lock = new Mutex();
		urgentQueue = new Urgent();
		vc = new VarCond(lock,urgentQueue);
	}

    	private  int contaprocessi;
	    private  Mutex lock;
	    private  Urgent urgentQueue;
    	private  VarCond vc;


	private void entramonitor() {
		lock.MutexWait();
	}

	private void escimonitor() {
		if (urgentQueue.queue())
			urgentQueue.urgentSignal();
		else
			lock.MutexSignal();
	}


	/**
 	  incrementa il numero di processi attivi
	 */
   	public void incrementa() {
	  	  entramonitor();
        contaprocessi++;
	    	escimonitor();
    	}

	/**
 	 decrementa il numero di processi attivi e se contaprocessi=0 e vc.queue!=0 libero
	 il processo
	 */
    	public void decrementa() {
	  	entramonitor();
      contaprocessi--;
		  if (vc.queue())
		  {if (contaprocessi==0)
		   vc.varCondSignal();}

		escimonitor();
	    }

	/**
	 se ci sono processi attivi si blocca sulla variabile condizione
    */
	    	public void processi(){
		  	entramonitor();
			if (contaprocessi!=0) vc.varCondWait() ;
			escimonitor();
		    }



}

