//SERVLET PER LA GESTIONE DEGLI ORDINi


import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.lang.*;
import java.net.*;
import java.util.*;

public class Servl_Order extends HttpServlet
{
	private PrintWriter returned;
	
	

	private int nzone;
	private int npizzetot;
	private int srvmax;
	
	private String fast;
	private String XMLstring;
	
	
//Gestione della richiest POST
	
	public void doPost(HttpServletRequest req, HttpServletResponse resp)
				throws ServletException,IOException
	{
		String str;

		int randomsrv=0,l=0;
		Random r=new Random();
		resp.setContentType("text/html");
		returned=resp.getWriter();

		/*------lettura dal file di configurazione------(eseguita in parallelo)
			dei parametri	npizzetot,nzone,srvmax	*/

		BufferedReader rconf= new BufferedReader(new FileReader("c:/plztemp/jproject/pppconf.txt"));
		npizzetot=Integer.parseInt(rconf.readLine());
		nzone=Integer.parseInt(rconf.readLine());
		srvmax=Integer.parseInt(rconf.readLine());
		rconf.close();
		
		int[] porta=new int[srvmax];
		String[] host=new String[srvmax];
	
		if(checkform(req)){
			try{
			
			//------lettura dei server disponibili-------------------------
	
				BufferedReader rserv= new BufferedReader(new FileReader("c:/plztemp/jproject/pppserv.txt"));
				while(rserv.ready()){
					
					porta[l]=Integer.parseInt(rserv.readLine());
					host[l]=rserv.readLine();
					l++;
				}	
				
			//------Generazione casuale del server a cui connettersi-------------------
			
				randomsrv=r.nextInt(srvmax-1);
				rserv.close();
			}catch(Exception e){
				sendpage("Errore nella lettura del file");
			}
			l=0;
			while(l<srvmax){
			try{
				
				
				
				Socket s=new Socket(host[randomsrv],porta[randomsrv]);		
				s.setSoTimeout(15000);
				BufferedReader in=new BufferedReader(new InputStreamReader(s.getInputStream()));
				PrintWriter outp=new PrintWriter(s.getOutputStream(),true);
				
				//invio stringhe ordini
				outp.println(fast);
				
				if(in.readLine().trim().equals("ok")){
					
					outp.println(XMLstring);
					str=in.readLine();
					if(str.equals("Non so gestire l'ordine")){
						
						sendpage("Siamo Spiacenti, il suo ordine non  stato gestito correttamente, le pizzerie potrebbero essere chiuse, la preghiamo di riprovare. Grazie");
										
						}else{
						sendpage("L'ordine  stato inviato correttamente alla pizzeria "+str+",  sarete serviti al pi presto possibile.Grazie!!");
					}
				}else{
					sendpage("Errore nella gestione dell'ordine...Siamo spiacenti, la preghiamo di riprovare ");
				}
				break;
			}catch(Exception ex){
			
			// In tal caso devo gestire la possibilit di connettermi con altri server	
		
				sendpage("Errore (srvlt): il server "+host[randomsrv]+":"+porta[randomsrv]+" non risponde: tentativo con un altro server... ");
				l++;
				randomsrv++;
				if(randomsrv>=srvmax)randomsrv=0;
				
			}
			}
		}
	}
		
//Invio di pagine HTML Al Cliente
		
	private void sendpage(String ht){
		returned.println("<HTML><HEAD>");
		returned.println("<title>MESSAGGIO</title");
		returned.println("</HEAD><BODY>");
		returned.println("<H3 ALIGN=CENTER COLOR=red>www.PPPizza.it</H3>");
		returned.println("<H1 ALIGN=CENTER>"+ht+"</H1>");
		returned.println("<p align=center> <a href=http://192.168.200.115:81/pizza1.htm >Torna alla home page</a></p>");
		returned.println("<p align=center> <a href=http://192.168.200.115:81/menu.htm >Torna al men</a></p>");
		returned.println("</BODY></HTML>");

	}

 	
	
//controllo dei parametri della form
	
	private boolean checkform(HttpServletRequest r)
		{
		try{
			int i=3;
			int sum=0,temp;
			StringBuffer tempxml= new StringBuffer(300);
			StringBuffer tempfast= new StringBuffer(20);
			tempxml.append("<Ordine><cliente>");
			String[] gener=new String[npizzetot+5];
			Enumeration params=r.getParameterNames();
			
			//Nessun Parametro
			
			if(params==null){
				sendpage("ERRORE;Errore nell'immissione dei Parametri");
				return false;
			}
			
			//controllo parametri
			
			while(params.hasMoreElements()){
				String par=(String)params.nextElement();
				String val=r.getParameter(par);						 
				if(val.equals("")){
					sendpage("ERRORE:Parametro non valido o vuoto");
					return false;
				}
				if(par.equals("zona")){
					if(Integer.parseInt(val)>=nzone){
						sendpage("ERRORE: Zona non valida");
						return false;
					}
					tempfast.append(val+",");
					continue;
				}

				/* i campi della form non sono inviati secondo l'ordine nella 
					pagina web...*/
			
				if(par.equals("nome")){gener[0]=val;continue;}
				if(par.equals("cognome")){gener[1]=val;continue;}
				if(par.equals("indirizzo")){gener[2]=val;continue;}
				if(par.equals("submit"))continue;
				if(val.equals("0"))continue;

				gener[i]=par+val;
				i++;
				sum+=Integer.parseInt(val);
			}
			if(sum==0){
				sendpage("ERRORE: NON HAI ORDINATO NESSUNA PIZZA!");
				return false;
			}
			tempfast.append(sum);			
			fast=tempfast.toString();
			
			//Formatta la stringa di gestione

			tempxml.append(gener[0]+" "+gener[1]+"</cliente><indirizzo>");
			tempxml.append(gener[2]+"</indirizzo><pizze>");
			for(int j=3;j<i;j++)tempxml.append(gener[j]+".");
			tempxml.append("</pizze></Ordine>");
			
			//Formatta la stringa XML
			
			XMLstring=tempxml.toString();

		}catch(Exception ex){
			sendpage("EXCEPTION"+ex.toString());
			return false;
		}
		return true;
	}	
}		
	
		
	
	
		
		